code	segment	'code'
	assume	cs:code,ds:code

	org	2ch
envseg	label	word			; pointer to env seg

	org	100h
start:	jmp	near ptr init		; jump to install routine
	dw	0

new2f:	cmp	ax,1510h		; device driver request?
	jne	start
	cmp	byte ptr es:[bx+2],83h	; seek function?
	jne	start

	sti				; enable interrupts

	inc	byte ptr es:[bx+2]	; change to play function
	db	66h			; dword
	push	word ptr es:[bx+14h]	; push seek start
	db	66h			; dword
	pop	word ptr es:[bx+0eh]	; pop play start
	db	66h			; dword
	push	0			; push play length
	db	66h			; dword
	pop	word ptr es:[bx+12h]	; pop play length

	pushf				; call old handler
	push	cs
	call	start

	retf	2			; return, drop flags on stack

init:	mov	ax,352fh		; create jump to old handler
	int	21h
	inc	byte ptr start
	mov	word ptr start+1,bx
	mov	word ptr start+3,es

	mov	dx,offset new2f		; install new handler
	mov	ah,25h
	int	21h

	mov	es,envseg		; free env seg
	mov	ah,49h
	int	21h

	mov	dx,0013h		; terminate leaving DX paras resident
	mov	ax,3100h
	int	21h

code	ends

	end	start
